#
# spec file for package tigervnc
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%define vncgroup vnc
%define vncuser vnc

%define tlskey  %{_sysconfdir}/vnc/tls.key
%define tlscert %{_sysconfdir}/vnc/tls.cert

%define _unitdir %{_prefix}/lib/systemd/system

%if 0%{?suse_version} >= 1500
%define use_firewalld 1
%else
%define use_firewalld 0
%endif

Name:           tigervnc
Version:        1.9.0
Release:        lp151.4.6.1
Provides:       tightvnc = 1.3.9
Obsoletes:      tightvnc < 1.3.9
Provides:       vnc
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  cmake
BuildRequires:  fltk-devel >= 1.3.3
BuildRequires:  gcc-c++
BuildRequires:  gcc-c++
BuildRequires:  java-devel >= 1.6.0
BuildRequires:  jpackage-utils
BuildRequires:  libjpeg-devel
BuildRequires:  libopenssl-devel
BuildRequires:  libtool
BuildRequires:  nasm
BuildRequires:  xorg-x11-server-sdk
BuildRequires:  xorg-x11-server-source
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(xext)
BuildRequires:  pkgconfig(xproto)
BuildRequires:  pkgconfig(xtst)
# Because of keytool to build java client
BuildRequires:  libgcrypt-devel
BuildRequires:  libgpg-error-devel
BuildRequires:  mozilla-nss
BuildRequires:  pam-devel
BuildRequires:  pkg-config
BuildRequires:  systemd-rpm-macros
BuildRequires:  xmlto
BuildRequires:  xorg-x11-libICE-devel
BuildRequires:  xorg-x11-libSM-devel
BuildRequires:  pkgconfig(bigreqsproto) >= 1.1.0
BuildRequires:  pkgconfig(compositeproto) >= 0.4
BuildRequires:  pkgconfig(damageproto) >= 1.1
BuildRequires:  pkgconfig(dri)
BuildRequires:  pkgconfig(egl)
BuildRequires:  pkgconfig(fixesproto) >= 4.1
BuildRequires:  pkgconfig(fontsproto)
BuildRequires:  pkgconfig(fontutil)
BuildRequires:  pkgconfig(gbm)
BuildRequires:  pkgconfig(gl)
BuildRequires:  pkgconfig(glproto)
BuildRequires:  pkgconfig(gnutls)
BuildRequires:  pkgconfig(inputproto)  >= 1.9.99.902
BuildRequires:  pkgconfig(kbproto) >= 1.0.3
BuildRequires:  pkgconfig(libtasn1)
BuildRequires:  pkgconfig(openssl)
BuildRequires:  pkgconfig(pciaccess) >= 0.8.0
BuildRequires:  pkgconfig(pixman-1) >= 0.15.20
BuildRequires:  pkgconfig(presentproto) >= 1.0
BuildRequires:  pkgconfig(randrproto) >= 1.2.99.3
BuildRequires:  pkgconfig(recordproto) >= 1.13.99.1
BuildRequires:  pkgconfig(renderproto) >= 0.11
BuildRequires:  pkgconfig(resourceproto)
BuildRequires:  pkgconfig(scrnsaverproto) >= 1.1
BuildRequires:  pkgconfig(videoproto)
BuildRequires:  pkgconfig(xau)
BuildRequires:  pkgconfig(xcmiscproto) >= 1.2.0
BuildRequires:  pkgconfig(xdmcp)
BuildRequires:  pkgconfig(xextproto) >= 7.0.99.3
BuildRequires:  pkgconfig(xf86driproto) >= 2.1.1
BuildRequires:  pkgconfig(xfont) >= 1.4.2
BuildRequires:  pkgconfig(xfont2)
BuildRequires:  pkgconfig(xineramaproto)
BuildRequires:  pkgconfig(xkbfile)
BuildRequires:  pkgconfig(xorg-macros) >= 1.14
BuildRequires:  pkgconfig(xproto)  >= 7.0.17
BuildRequires:  pkgconfig(xtrans) >= 1.2.2
%if 0%{?suse_version} >= 1315
Requires(post):   update-alternatives
Requires(postun): update-alternatives
%endif
Url:            http://tigervnc.org/
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Summary:        An implementation of VNC
License:        GPL-2.0-only AND MIT
Group:          System/X11/Servers/XF86_4
Source1:        https://github.com/TigerVNC/tigervnc/archive/v%{version}.tar.gz
Source4:        10-libvnc.conf
Source5:        vnc-server.susefirewall
Source6:        vnc-httpd.susefirewall
Source7:        vnc.reg
Source8:        vncpasswd.arg
Source9:        vnc.pam
Source10:       with-vnc-key.sh
Source11:       index.vnc
Source12:       x11vnc
Source13:       xvnc@.service
Source14:       xvnc.socket
Source15:       xvnc-novnc.service
Source16:       xvnc-novnc.socket
Source17:       tigervnc.firewalld
Source18:       tigervnc-https.firewalld
Source19:       xvnc.target

Patch1:         tigervnc-newfbsize.patch
Patch2:         tigervnc-clean-pressed-key-on-exit.patch
Patch3:         u_tigervnc-ignore-epipe-on-write.patch
Patch4:         n_tigervnc-date-time.patch
Patch5:         u_tigervnc-cve-2014-8240.patch
Patch6:         u_tigervnc_update_default_vncxstartup.patch
Patch7:         u_build_libXvnc_as_separate_library.patch
Patch8:         u_tigervnc-add-autoaccept-parameter.patch
Patch9:         u_change-button-layout-in-ServerDialog.patch
Patch10:        n_correct_path_in_desktop_file.patch
Patch11:        U_viewer-reset-ctrl-alt-to-menu-state-on-focus.patch
Patch21:        0001-Make-ZlibInStream-more-robust-against-failures.patch
Patch22:        0002-Encapsulate-PixelBuffer-internal-details.patch
Patch23:        0003-Restrict-PixelBuffer-dimensions-to-safe-values.patch
Patch24:        0004-Add-write-protection-to-OffsetPixelBuffer.patch
Patch25:        0005-Handle-empty-Tight-gradient-rects.patch
Patch26:        0006-Add-unit-test-for-PixelFormat-sanity-checks.patch
Patch27:        0007-Fix-depth-sanity-test-in-PixelFormat.patch
Patch28:        0008-Add-sanity-checks-for-PixelFormat-shift-values.patch
Patch29:        0009-Remove-unused-FixedMemOutStream.patch
Patch30:        0010-Use-size_t-for-lengths-in-stream-objects.patch
Patch31:        0011-Be-defensive-about-overflows-in-stream-objects.patch
Patch32:        0012-Add-unit-tests-for-PixelFormat.is888-detection.patch
Patch33:        0013-Handle-pixel-formats-with-odd-shift-values.patch
Patch40:        U_Avoid-potential-crash-when-replacing-buffer-in-Plain.patch

%description
TigerVNC is an implementation of VNC (Virtual Network Computing), a
client/server application that allows users to launch and interact
with graphical applications on remote machines. TigerVNC is capable
of running 3D and video applications. TigerVNC also provides
extensions for advanced authentication methods and TLS encryption.

%package -n xorg-x11-Xvnc
Requires(post): /usr/sbin/useradd
Requires(post): /usr/sbin/groupadd
Requires(post): /bin/awk
Requires(post): systemd
%if %{use_firewalld}
Requires(post): firewall-macros
%endif
# Needed to generate certificates
Requires:       windowmanager
Requires:       xauth
Requires:       xinit
Requires:       xkbcomp
Requires:       xkeyboard-config
Requires:       xorg-x11-fonts-core
Requires:       openssl(cli)
# For the with-vnc-key.sh script
Requires:       /bin/hostname
%{?systemd_requires}
%ifnarch s390 s390x
Recommends:     xorg-x11-Xvnc-module
%endif
Provides:       tightvnc = 1.3.9
Provides:       xorg-x11-Xvnc:/usr/lib/vnc/with-vnc-key.sh
Obsoletes:      tightvnc < 1.3.9
Summary:        TigerVNC implementation of Xvnc
Group:          System/X11/Servers/XF86_4

%description -n xorg-x11-Xvnc
This is the TigerVNC implementation of Xvnc.

%ifnarch s390 s390x
%package -n xorg-x11-Xvnc-module
Requires:       xorg-x11-Xvnc
Summary:        VNC module for X server
Group:          System/X11/Servers/XF86_4
%{x11_abi_extension_req}

%description -n xorg-x11-Xvnc-module
This module allows to share content of X server's screen over VNC.
It is loaded into X server as a module if enable in X server's
configuration.
%endif

%package -n xorg-x11-Xvnc-novnc
Requires:       novnc
Requires:       python3-websockify
Requires:       xorg-x11-Xvnc
%{?systemd_requires}
Summary:        NoVNC service for Xvnc
Group:          System/X11/Servers/XF86_4
BuildArch:      noarch

%description -n xorg-x11-Xvnc-novnc
A service that starts noVNC linked to Xvnc server.

%package -n xorg-x11-Xvnc-java
BuildArch:      noarch

%{?systemd_requires}
Summary:        VNC viewer in java
Group:          System/X11/Servers/XF86_4

%description -n xorg-x11-Xvnc-java
A VNC client written in java that can be used as standalone application or as
an applet inside web page.

%package -n libXvnc1
Summary:        X extension to control VNC module
Group:          System/Libraries

%description -n libXvnc1
Xvnc extension allows X clients to read and change VNC configuration.

%package -n libXvnc-devel
Summary:        X extension to control VNC module
Group:          Development/Libraries/C and C++
Requires:       libXvnc1 = %version

%description -n libXvnc-devel
Xvnc extension allows X clients to read and change VNC configuration.

%package x11vnc
Summary:        Wrapper that starts x0vncserver
Group:          System/X11/Servers/XF86_4
Requires:       python
Requires:       xorg-x11-Xvnc
Provides:       x11vnc
Conflicts:      x11vnc
BuildArch:      noarch

%description x11vnc
This is a wrapper that looks like x11vnc, but starts x0vncserver instead.
It maps common x11vnc arguments to x0vncserver arguments.

%prep
%setup -T -b1 -q
cp -r /usr/src/xserver/* unix/xserver/

%patch1 -p1
%patch2 -p1
%patch3 -p0
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch40 -p1

pushd unix/xserver
patch -p1 < ../xserver120.patch
popd

%build
export CXXFLAGS="%optflags"
export CFLAGS="%optflags"
# Build all tigervnc
cmake -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} -DCMAKE_BUILD_TYPE=RelWithDebInfo
make %{?_smp_mflags}

# Build Xvnc server
pushd unix/xserver
autoreconf -fi
%configure \
        --disable-xorg --disable-xnest --disable-xvfb --disable-dmx \
        --disable-xwin --disable-xephyr --disable-kdrive --with-pic \
        --disable-static --disable-xinerama \
        --with-xkb-path="/usr/share/X11/xkb" \
        --with-xkb-output="/var/lib/xkb/compiled" \
        --enable-glx --enable-dri \
%ifnarch s390 s390x
	--enable-dri2 \
%endif
        --disable-config-dbus \
        --disable-config-hal \
        --disable-config-udev \
        --without-dtrace \
        --disable-unit-tests \
        --disable-devel-docs \
        --with-fontrootdir=/usr/share/fonts \
        --disable-selective-werror
make %{?_smp_mflags} V=1
popd

# Build java client
pushd java
cmake -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} -DJAVACFLAGS="-encoding utf8 -source 1.6 -target 1.6"
make %{?_smp_mflags}
popd

%install

%make_install

mv $RPM_BUILD_ROOT/usr/bin/vncviewer $RPM_BUILD_ROOT/usr/bin/vncviewer-tigervnc
mv $RPM_BUILD_ROOT/usr/share/man/man1/vncviewer.1 $RPM_BUILD_ROOT/usr/share/man/man1/vncviewer-tigervnc.1

pushd unix/xserver
%make_install
popd

pushd java
mkdir -p $RPM_BUILD_ROOT%{_datadir}/vnc/classes
install -m755 VncViewer.jar $RPM_BUILD_ROOT%{_datadir}/vnc/classes
popd

%ifnarch s390x
install -D -m 644 %{SOURCE4} $RPM_BUILD_ROOT/etc/X11/xorg.conf.d/10-libvnc.conf
%endif

%if %{use_firewalld}
install -D -m 644 %{SOURCE17} $RPM_BUILD_ROOT%{_libexecdir}/firewalld/services/tigervnc.xml
install -D -m 644 %{SOURCE18} $RPM_BUILD_ROOT%{_libexecdir}/firewalld/services/tigervnc-https.xml
%else
install -D -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/SuSEfirewall2.d/services/vnc-server
install -D -m 644 %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/SuSEfirewall2.d/services/vnc-httpd
%endif

install -D -m 644 %{SOURCE7} $RPM_BUILD_ROOT/etc/slp.reg.d/vnc.reg
install -D -m 755 %{SOURCE8} $RPM_BUILD_ROOT%{_bindir}/vncpasswd.arg
install -D -m 644 %{SOURCE9} $RPM_BUILD_ROOT/etc/pam.d/vnc
install -D -m 644 %{SOURCE11} $RPM_BUILD_ROOT%{_datadir}/vnc/classes
%if 0%{?suse_version} >= 1315
ln -s -f %{_sysconfdir}/alternatives/vncviewer $RPM_BUILD_ROOT%{_bindir}/vncviewer
ln -s -f %{_sysconfdir}/alternatives/vncviewer.1.gz $RPM_BUILD_ROOT%{_mandir}/man1/vncviewer.1.gz
%endif

mkdir -p %{buildroot}%{_sbindir}
ln -sf %{_sbindir}/service %{buildroot}%{_sbindir}/rcxvnc
ln -sf %{_sbindir}/service %{buildroot}%{_sbindir}/rcxvnc-novnc

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/vnc

mkdir -p $RPM_BUILD_ROOT%{_libexecdir}/vnc
install -D -m 755 %{SOURCE10} $RPM_BUILD_ROOT%{_libexecdir}/vnc

install -D -m 755 %{SOURCE12} $RPM_BUILD_ROOT%{_bindir}/x11vnc

install -D %{SOURCE13} -m 0444 %{buildroot}%{_unitdir}/xvnc@.service
install -D %{SOURCE14} -m 0444 %{buildroot}%{_unitdir}/xvnc.socket
install -D %{SOURCE15} -m 0444 %{buildroot}%{_unitdir}/xvnc-novnc.service
install -D %{SOURCE16} -m 0444 %{buildroot}%{_unitdir}/xvnc-novnc.socket
install -D %{SOURCE19} -m 0444 %{buildroot}%{_unitdir}/xvnc.target

rm -rf $RPM_BUILD_ROOT/usr/share/doc/tigervnc-*

%find_lang '%{name}'

%post
%if 0%{?suse_version} >= 1315
%_sbindir/update-alternatives \
    --install %{_bindir}/vncviewer vncviewer %{_bindir}/vncviewer-tigervnc 20 \
    --slave %{_mandir}/man1/vncviewer.1.gz  vncviewer.1.gz  %{_mandir}/man1/vncviewer-tigervnc.1.gz
%endif

%postun
%if 0%{?suse_version} >= 1315
if [ "$1" = 0 ] ; then
   "%_sbindir/update-alternatives" --remove vncviewer /usr/bin/vncviewer-tigervnc
fi
%endif

%pre -n xorg-x11-Xvnc
%service_add_pre xvnc.socket

getent group %{vncgroup} > /dev/null || groupadd -r %{vncgroup} || :
getent passwd %{vncuser} > /dev/null || useradd -r -g %{vncgroup} -d /var/lib/empty -s /sbin/nologin -c "user for VNC" %{vncuser} || :
usermod -G shadow -a %{vncuser} || :

%post -n xorg-x11-Xvnc
%service_add_post xvnc.socket

%if %{use_firewalld}
%{firewalld_reload}
%endif

# If there is old xinetd configuration file and VNC service was enabled, enable the systemd service too.
# Once we are done, RPM will rename the file to /etc/xinetd.d/vnc.rpmsave, so this won't happen
# during future updates.
if [ -e /etc/xinetd.d/vnc ] && awk '
  BEGIN { in_vnc1_section = 0 }
  /service.*vnc1/ { in_vnc1_section = 1 }
  in_vnc1_section && /disable\s*=\s*yes/ { exit 1 }
  in_vnc1_section && /}/ { exit 0 }
  ' /etc/xinetd.d/vnc;
then
  echo "Found old xinetd configuration with enabled VNC service. Enabling xvnc.socket."
  systemctl enable xvnc.socket
fi

%preun -n xorg-x11-Xvnc
%service_del_preun xvnc.socket

%postun -n xorg-x11-Xvnc
%service_del_postun xvnc.socket

%pre -n xorg-x11-Xvnc-novnc
%service_add_pre xvnc-novnc.service
%service_add_pre xvnc-novnc.socket

%post -n xorg-x11-Xvnc-novnc
%service_add_post xvnc-novnc.service
%service_add_post xvnc-novnc.socket

%preun -n xorg-x11-Xvnc-novnc
%service_del_preun xvnc-novnc.service
%service_del_preun xvnc-novnc.socket

%postun -n xorg-x11-Xvnc-novnc
%service_del_postun xvnc-novnc.service
%service_del_postun xvnc-novnc.socket

%post -n libXvnc1 -p /sbin/ldconfig

%postun -n libXvnc1 -p /sbin/ldconfig

%files -f %{name}.lang
%defattr(-,root,root,-)
%ghost %{_bindir}/vncviewer
%{_bindir}/vncviewer-tigervnc
%doc LICENCE.TXT README.rst
%ghost %_mandir/man1/vncviewer.1.gz
%doc %_mandir/man1/vncviewer-tigervnc.1.gz
%if 0%{?suse_version} >= 1315
%ghost %_sysconfdir/alternatives/vncviewer
%ghost %_sysconfdir/alternatives/vncviewer.1.gz
%endif

%dir %_datadir/icons/hicolor/16x16
%dir %_datadir/icons/hicolor/16x16/apps
%dir %_datadir/icons/hicolor/22x22
%dir %_datadir/icons/hicolor/22x22/apps
%dir %_datadir/icons/hicolor/24x24
%dir %_datadir/icons/hicolor/24x24/apps
%dir %_datadir/icons/hicolor/32x32
%dir %_datadir/icons/hicolor/32x32/apps
%dir %_datadir/icons/hicolor/48x48
%dir %_datadir/icons/hicolor/48x48/apps
%dir %_datadir/icons/hicolor/scalable
%dir %_datadir/icons/hicolor/scalable/apps

%_datadir/icons/hicolor/*/apps/tigervnc.png
%_datadir/icons/hicolor/scalable/apps/tigervnc.svg

%_datadir/applications/vncviewer.desktop

%files -n xorg-x11-Xvnc
%doc LICENCE.TXT README.rst
%defattr(-,root,root)

%{_bindir}/Xvnc
%{_bindir}/vncconfig
%{_bindir}/vncpasswd
%{_bindir}/vncpasswd.arg
%{_bindir}/vncserver
%{_bindir}/x0vncserver

%exclude %{_mandir}/man1/Xserver.1*
%{_mandir}/man1/Xvnc.1*
%{_mandir}/man1/vncconfig.1*
%{_mandir}/man1/vncpasswd.1*
%{_mandir}/man1/vncserver.1*
%{_mandir}/man1/x0vncserver.1*

%{_unitdir}/xvnc@.service
%{_unitdir}/xvnc.socket
%{_unitdir}/xvnc.target
%{_sbindir}/rcxvnc

%exclude /var/lib/xkb/compiled/README.compiled

%if %{use_firewalld}
%dir %{_libexecdir}/firewalld
%dir %{_libexecdir}/firewalld/services
%{_libexecdir}/firewalld/services/tigervnc.xml
%{_libexecdir}/firewalld/services/tigervnc-https.xml
%else
%config %{_sysconfdir}/sysconfig/SuSEfirewall2.d/services/vnc-server
%config %{_sysconfdir}/sysconfig/SuSEfirewall2.d/services/vnc-httpd
%endif

%dir /etc/slp.reg.d
%config(noreplace) /etc/slp.reg.d/vnc.reg

%config %{_sysconfdir}/pam.d/vnc

%dir %attr(0755,%{vncuser},%{vncuser}) %{_sysconfdir}/vnc
%ghost %attr(0600,%{vncuser},%{vncuser}) %config(noreplace) %{tlskey}
%ghost %attr(0644,%{vncuser},%{vncuser}) %config(noreplace) %{tlscert}

%{_libexecdir}/vnc

%ifarch s390 s390x
# These would be in xorg-x11-Xvnc-module, but we don't build that on s390
%exclude /usr/%{_lib}/xorg/protocol.txt
%exclude /usr/%{_lib}/xorg/modules/extensions/libvnc.la
%exclude /usr/%{_lib}/xorg/modules/extensions/libvnc.so
%endif

%ifnarch s390 s390x
%files -n xorg-x11-Xvnc-module
%exclude /usr/%{_lib}/xorg/protocol.txt
%exclude /usr/%{_lib}/xorg/modules/extensions/libvnc.la
%{_libdir}/xorg/modules/extensions/libvnc.so
%config(noreplace) /etc/X11/xorg.conf.d/10-libvnc.conf
%endif

%files -n xorg-x11-Xvnc-novnc
%{_unitdir}/xvnc-novnc.service
%{_unitdir}/xvnc-novnc.socket
%{_sbindir}/rcxvnc-novnc

%files -n xorg-x11-Xvnc-java
%doc java/com/tigervnc/vncviewer/README
%{_datadir}/vnc

%files -n libXvnc1
%defattr(-,root,root)
%{_libdir}/libXvnc.so.1*

%files -n libXvnc-devel
%defattr(-,root,root)
%{_libdir}/libXvnc.so
%{_includedir}/X11/extensions/Xvnc.h

%files x11vnc
%defattr(-,root,root)
%{_bindir}/x11vnc

%changelog
* Wed May 13 2020 Stefan Dirsch <sndirsch@suse.com>
- U_Avoid-potential-crash-when-replacing-buffer-in-Plain.patch
  * fixes crash in free() when using "-f" option of vncpasswd
    command (bsc#1171519)
* Wed Jan  8 2020 Stefan Dirsch <sndirsch@suse.com>
- TigerVNC security fix:
  0001-Make-ZlibInStream-more-robust-against-failures.patch
  0002-Encapsulate-PixelBuffer-internal-details.patch
  0003-Restrict-PixelBuffer-dimensions-to-safe-values.patch
  0004-Add-write-protection-to-OffsetPixelBuffer.patch
  0005-Handle-empty-Tight-gradient-rects.patch
  0006-Add-unit-test-for-PixelFormat-sanity-checks.patch
  0007-Fix-depth-sanity-test-in-PixelFormat.patch
  0008-Add-sanity-checks-for-PixelFormat-shift-values.patch
  0009-Remove-unused-FixedMemOutStream.patch
  0010-Use-size_t-for-lengths-in-stream-objects.patch
  0011-Be-defensive-about-overflows-in-stream-objects.patch
  0012-Add-unit-tests-for-PixelFormat.is888-detection.patch
  0013-Handle-pixel-formats-with-odd-shift-values.patch
  * stack use-after-return due to incorrect usage of stack memory
    in ZRLEDecoder (CVE-2019-15691, bsc#1159856)
  * improper value checks in CopyRectDecode may lead to heap
    buffer overflow (CVE-2019-15692, bsc#1160250)
  * heap buffer overflow in TightDecoder::FilterGradient
    (CVE-2019-15693, bsc#1159858)
  * improper error handling in processing MemOutStream may lead
    to heap buffer overflow (CVE-2019-15694, bsc#1160251
  * stack buffer overflow, which could be triggered from
    CMsgReader::readSetCurso (CVE-2019-15695, bsc#1159860)
* Thu Jan 17 2019 msrb@suse.com
- Switch websocket dependency to python3. (bsc#1119737)
* Thu Jan 17 2019 msrb@suse.com
- Do not build xorg-x11-Xvnc-module on s390. It fails to build
  because macros.xorg-server is incomplete on s390 and the module
  would be useless without real X server anyway.
* Tue Jan  8 2019 msrb@suse.com
- Add U_viewer-reset-ctrl-alt-to-menu-state-on-focus.patch
  * Fix the ALT and CTRL buttons in viewer's F8 menu. (bsc#1119354)
* Wed Sep 19 2018 Jason Sikes <jsikes@suse.de>
- Changed "openssl" requirement to "openssl(cli)"
  * (bsc#1101470)
* Mon Aug  6 2018 msrb@suse.com
- Add xvnc.target to fix xvnc-novnc.service's dependency.
  (bnc#1103552)
- Split the X server's VNC module into subpackage and give it
  dependency on the current extension ABI.
* Thu Aug  2 2018 msrb@suse.com
- Update to tigervnc 1.9.0
  * Alternative, "raw" keyboard mode in the native client and all servers
  * CapsLock/NumLock/ScrollLock synchronisation in the native client and all servers
  * Automatic "repair" of JPEG artefacts on screen in all servers
  * Support for UNIX sockets in the native client and in the UNIX servers
  * Both clients now warn when sending the password over a possibly insecure channel
  * Performance improvements in the Java client
  * The Java client now requires Java 7
  * Improved high latency handling in all servers
  * Slightly better keyboard handling in x0vncserver
  * x0vncserver now supports cursors and screen resize
  * Xorg 1.20 can now be used as a base for Xvnc/libvnc.so
  - Fixes bnc#1103537
- Removed patches (included in 1.9.0):
  * u_tigervnc-show-unencrypted-warning.patch
  * U_allow_multiple_certs_with_same_dn_in_saved_certs_file.patch
  * U_handle_certificate_verification_for_saved_certs_correctly.patch
  * u_Unset-pixel-buffer-when-x0vncserver-client-disconnect.patch
  * u_add-support-for-X-server-1.20.0.patch
  * U_vncviewer-Fix-fullscreen-scrolling.patch
  * U_vncviewer-Fix-scrollbar-visibility.patch
- Removed patches (no longer needed):
  * tigervnc-1.8.0-nowindows.patch
- Refreshed patches:
  * n_tigervnc-date-time.patch
  * tigervnc-clean-pressed-key-on-exit.patch
  * u_tigervnc-add-autoaccept-parameter.patch
  * u_tigervnc-ignore-epipe-on-write.patch
- Added patches:
  * n_correct_path_in_desktop_file.patch
- Fixed typo in 10-libvnc.conf
* Fri Jun  8 2018 msrb@suse.com
- Updated u_add-support-for-X-server-1.20.0.patch to version sent
  upstream. Fixes GLX initialization.
* Wed Jun  6 2018 msrb@suse.com
- U_vncviewer-Fix-fullscreen-scrolling.patch,
  U_vncviewer-Fix-scrollbar-visibility.patch
  * Fix scrolling in vncviewer. (boo#1095664)
- u_add-support-for-X-server-1.20.0.patch
  * Fix build against X server 1.20.0.
* Tue Apr 24 2018 msrb@suse.com
- Reload firewalld files after installation.
* Wed Apr 11 2018 jengelh@inai.de
- Limit feature description to openSUSE. Ensure neutrality of
  description.
* Wed Apr 11 2018 msrb@suse.com
- Add u_change-button-layout-in-ServerDialog.patch
  * To fit strings in languages with longer words... (bnc#1084865)
- Refresh n_tigervnc-date-time.patch
  * Completely hide the build time (bnc#1082968)
* Thu Mar 22 2018 msrb@suse.com
- Enable xvnc.socket if upgraded from previous installation that
  had VNC enabled in xinetd configuration. (bnc#1085974)
- Subpackage xorg-x11-Xvnc must also obsolete tightvnc.
* Wed Feb 28 2018 msrb@suse.com
- Replace SuSEFirewall2 by firewalld. (bnc#1081952)
* Mon Dec 18 2017 dimstar@opensuse.org
- Do not mess with /usr/lib*64)?/debug: this is RPM's playground
  for debuginfo packages.
* Mon Dec 18 2017 fstrba@suse.com
- Added patch:
  * tigervnc-1.8.0-nowindows.patch
    + Remove Windows code that is removed from jdk10
* Tue Dec 12 2017 msrb@suse.com
- Depend on pkgconfig's gl, egl and gbm instead of Mesa-devel.
  * Those dependencies are what the underlying X server really
    needs. Mesa-devel is too general and is a bottleneck in
    distribution build. (bnc#1071297)
* Tue Sep 26 2017 msrb@suse.com
- u_Unset-pixel-buffer-when-x0vncserver-client-disconnect.patch
  * Fixes crash in x0vncserver after client disconnects.
    (bnc#1058587)
* Mon Sep 25 2017 msrb@suse.com
- Add tigervnc-x11vnc wrapper for x0vncserver that replaces x11vnc.
  (fate#323207)
- Replace java applet with novnc as web-based VNC viewer.
  (fate#323880)
- Convert xinetd services to systemd socket activated services.
  (bnc#1058460)
* Mon Sep 11 2017 fstrba@suse.com
- Specify java source and target level 1.6 in order to be able to
  build with jdk9
* Fri Aug 11 2017 msrb@suse.com
- Disable MIT-SHM extension when running under vnc user.
  (bnc#1053373)
* Thu Jul 20 2017 msrb@suse.com
- U_allow_multiple_certs_with_same_dn_in_saved_certs_file.patch,
  U_handle_certificate_verification_for_saved_certs_correctly.patch
  * Fix certificate handling in the java client. (bnc#1041847)
- Refresh u_tigervnc-add-autoaccept-parameter.patch and apply it
  last.
- Make sure CN in generated certificate doesn't exceed 64
  characters. (bnc#1041847)
* Fri Jul  7 2017 msrb@suse.com
- Change with-vnc-key.sh to generate TLS certificate using current
  hostname. (bnc#1041847)
* Fri Jun  9 2017 tchvatal@suse.com
- Require java-deve >= 1.6.0 to avoid bootstrap fail
* Fri Jun  2 2017 meissner@suse.com
- removed unneeded -fPIC flags for CFLAGS, these made it avoid
  PIE support.
* Wed May 31 2017 msrb@suse.com
- Update to tigervnc 1.8.0
  * Overhaul of the Java client to match the look and behaviour of the native client
  * Initial work for multi-threaded decoding in the Java client
  * vncconfig no longer needed for clipboard with Xvnc/libvnc.so
  * vncserver has system wide config support
  * Full support for alpha cursors in Xvnc/libvnc.so and both viewers
- Removed patches:
  * U_Add-xorg-xserver-1.19-support.patch
  * U_tigervnc-fix-inetd-not-working-with-xserver-1-19.patch
  * U_tigervnc-better-check-for-screen-visibility.patch
* Mon Apr 10 2017 msrb@suse.com
- U_tigervnc-better-check-for-screen-visibility.patch
  * Crop operations to visible screen. (bnc#1032272)
* Thu Mar  2 2017 msrb@suse.com
- Readd index.vnc. (bnc#1026833)
* Mon Feb 20 2017 msrb@suse.com
- U_tigervnc-fix-inetd-not-working-with-xserver-1-19.patch
  * Fixes inetd mode with x server 1.19 (bnc#1025759)
* Wed Jan 25 2017 msrb@suse.com
- Update to tigervnc 1.7.1.
  * This is a security update for TigerVNC 1.7.0 which fixes a
    memory overflow issue via the RRE decoder. A malicious server
    could possibly use this issue to take control of the TigerVNC
    viewer.
* Wed Nov 30 2016 sndirsch@suse.com
- U_Add-xorg-xserver-1.19-support.patch
  * Add xorg-xserver 1.19 support
* Tue Sep 13 2016 msrb@suse.com
- Update to tigervnc 1.7.0.
  * Multi-threaded decoder in the FLTK viewer
  * Improved SSH integration in the Java viewer
  * Fine grained lock down of Xvnc parameters
  * Compatibility with Xorg 1.18
  * Lots of packaging fixes
  * Better compatibility with Vino, both in the FLTK and Java viewer
- Removed patches:
  * U_add_allowoverride_parameter.patch
  * U_include-vencrypt-only-if-any-subtype-present.patch
  * U_tigervnc_clear_up_zlibinstream_reset_behaviour.patch
  * u_xserver118.patch
* Mon Aug  8 2016 eich@suse.com
- Adding a generic 'windowmanager' requires which will be
  satisfied by any package providing 'windowmanager':
  Requires:       windowmanager
  (boo#981663).
* Thu Jun 16 2016 msrb@suse.com
- Generate VNC key and certificate on first use, not during
  installation. (bnc#982349)
* Mon Jun 13 2016 msrb@suse.com
- Add U_tigervnc_clear_up_zlibinstream_reset_behaviour.patch
  * Fix zlib stream reset in tight encoding. (bnc#963417)
* Tue May 24 2016 msrb@suse.com
- Add /etc/pam.d/vnc configuration and add vnc user to shadow
  group. (bnc#980326)
- Add dependency on fltk-devel version >= 1.3.3.
* Fri Apr 29 2016 msrb@suse.com
- Add U_add_allowoverride_parameter.patch and
    u_build_libXvnc_as_separate_library.patch (fate#319319)
- Add u_tigervnc-show-unencrypted-warning.patch (fate#319701)
* Wed Apr 27 2016 msrb@suse.com
- Add dependency on xorg-x11-fonts-core. (bnc#977019)
* Tue Jan 12 2016 msrb@suse.com
- Updated to tigervnc 1.6.0.
- Removed patches:
  * N_tigervnc_revert_fltk_1_3_3_requirements.patch
  * U_tigervnc-fix-reversed-logic-in-vncIsTCPPortUsed.patch
  * u_tigervnc-display-SHA-1-fingerprint-of-untrusted-certificate.patch
  * u_tigervnc-use-default-trust-manager-in-java-viewer-if-custom.patch
  * u_tigervnc-use_preferred_mode.patch
  * u_tigervnc-vncserver-clean-pid-files.patch
- Updated patches:
  * n_tigervnc-date-time.patch
  * u_tigervnc-add-autoaccept-parameter.patch
  * u_tigervnc_update_default_vncxstartup.patch
* Wed Dec 16 2015 msrb@suse.com
- u_tigervnc_update_default_vncxstartup.patch
  * Update default VNC xstartup script.
- Add dependency on xinit and icewm. (bnc#956537)
* Thu Nov 12 2015 msrb@suse.com
- u_xserver118.patch
  * Build with xserver 1.18.0.
* Thu Oct  1 2015 msrb@suse.com
- u_tigervnc-vncserver-clean-pid-files.patch
  * vncserver: Clean pid files of dead processes. (bnc#948392)
* Sun Sep 13 2015 msrb@suse.com
- U_tigervnc-fix-reversed-logic-in-vncIsTCPPortUsed.patch
  * Fixes Xvnc with -inetd parameter. (bnc#945600)
* Thu Aug 27 2015 hguo@suse.com
- VNC server cannot run without xauth and xkbcomp, therefore
  introduce these dependencies.
* Tue Aug 25 2015 msrb@suse.com
- Remove commented out DefaultDepth 16 from 10-libvnc.conf file.
  Using 16 bit depth can cause troubles and does not have any
  positives anymore, so lets not suggest it to users. (bnc#942982)
* Fri Jul 31 2015 dimstar@opensuse.org
- Add /usr/sbin/groupadd and /usr/sbin/useradd Requires(post) to
  xorg-x11-Xvnc: the scripts are creating users/groups.
* Wed Jul 15 2015 msrb@suse.com
- Updated to tigervnc 1.5.0.
- Dropped no longer needed patches:
  * tigervnc-sf3495623.patch
  * u_syslog.patch
  * u_tigervnc-build-with-xserver-1.17.patch
  * tigervnc-gnutls-3.4-required.patch
  * u_tigervnc-dont-send-ascii-control-characters.patch
  * u_terminate_instead_of_ignoring_restart.patch
- Dropped no longer needed index.vnc.
- Use encryption everywhere. (fate#318936)
  * u_tigervnc-display-SHA-1-fingerprint-of-untrusted-certificate.patch
  * u_tigervnc-use-default-trust-manager-in-java-viewer-if-custom.patch
  * u_tigervnc-add-autoaccept-parameter.patch
- Work with fltk 1.3.2.
  * N_tigervnc_revert_fltk_1_3_3_requirements.patch
* Thu May 28 2015 ro@suse.de
- add buildrequires for xf86driproto and presentproto to
  match xserver
- disable dri2 on s390/s390x
* Mon Apr 20 2015 msrb@suse.com
- u_syslog.patch, vnc.xinetd
  * Add logging to syslog.
* Wed Apr 15 2015 dimstar@opensuse.org
- Add tigervnc-gnutls-3.4-required.patch: raise gnutls dependency
  to 3.2. Simplifies code, but makes it build with gnutls 3.4.
  Patch taken from Arch.
* Tue Apr 14 2015 meissner@suse.com
- Updated to tigervnc 1.4.3
  * Upstream patches applied to the underlying Xorg code base to mitigate
    CVE-2015-0255 / bsc#915810.
  * Fixes for performance regressions introduced in 1.4.0.
  * Character encoding of clipboard text send by Java viewer now strictly
    adheres to the RFB specification.
* Wed Apr  1 2015 msrb@suse.com
- u_terminate_instead_of_ignoring_restart.patch
  * Terminate instead of ignoring restart. (bnc#920969)
* Tue Feb 24 2015 msrb@suse.com
- Fix build against X server 1.17.x.
  * u_tigervnc-build-with-xserver-1.17.patch
* Thu Feb  5 2015 msrb@suse.com
- Use xserver sources from xorg-x11-server-source.
- Drop no longer needed patches:
  * N_xorg-server-xdmcp.patch
  * n_tigervnc-dont-build-gtf.patch
* Fri Jan  9 2015 msrb@suse.com
- Update to tigervnc 1.4.1 on xorg-server 1.16.1.
- Drop upstreamed or obsolete patches:
    tigervnc-sf3492352.diff
    u_aarch64-support.patch
    u_tigervnc-check-shm-harder.patch
    u_arch-Fix-image-and-bitmap-byte-order-for-ppc64le.patch
    u_tigervnc-1.3.0-fix-use-after-free.patch
    tigervnc-1.2.80-fix-int-to-pointer.patch
* Sun Nov 16 2014 oscar@naiandei.net
- add -fPIC to CFLAGS and CXXFLAGS to compile correctly on armv7l
* Thu Oct 30 2014 msrb@suse.com
- u_tigervnc-cve-2014-8240.patch
  * Prevent potentially dangerous integer overflow.
    (bnc#900896 CVE-2014-8240)
* Mon Oct 13 2014 msrb@suse.com
- u_tigervnc-use_preferred_mode.patch
  * Mark user chosen resolution as preferred. (bnc#896540)
* Mon Aug 18 2014 sndirsch@suse.com
- use update-alternatives only on openSUSE > 13.1
* Mon Aug 18 2014 msrb@suse.com
- u_tigervnc-check-shm-harder.patch
  * Check if SHM really works before deciding to use it.
    (bnc#890580)
* Mon Aug  4 2014 msrb@suse.com
- U_include-vencrypt-only-if-any-subtype-present.patch
  * Do not automatically offer VeNCrypt security if none of it's
    subtypes is selected. (bnc#889781)
* Wed Jun  4 2014 msrb@suse.com
- Fix some errors reported by rpmlint.
* Thu May 29 2014 crrodriguez@opensuse.org
- n_tigervnc-date-time.patch package republishes everyday
  and gets on my nerves, this is because the binaries contain
  hardcoded timestamps, avoid that.
- export CXXFLAGS and CFLAGS before building ttigervnc otherwise
  it gets built without optimization.
- Make build verbose so it rpmlint catches errors like the above ones.
* Wed May 28 2014 msrb@suse.com
- Use update-alternatives.
* Tue May 20 2014 msrb@suse.com
- u_tigervnc-ignore-epipe-on-write.patch
  * Do not display error message because of EPIPE on write.
    (bnc#864676)
* Fri May 16 2014 msrb@suse.com
- Update to version 1.3.1
  * Security release (CVE-2014-0011).
* Mon Apr 28 2014 sndirsch@suse.com
- added missing pkgconfig(xorg-macros) >= 1.14
* Sat Apr 26 2014 sndirsch@suse.com
- xorg-x11-Xvnc: require xkeyboard-config (bnc#875329)
* Fri Apr 25 2014 msrb@suse.com
- vnc.xinetd
  * Do not use 16 bpp by default anymore. The network trafic gain
    of 16 bpp together with Tight encoding is arguable. 16 bpp
    causes graphical issues and is known to not work properly
    in Mesa. (bnc#871965)
* Mon Mar 17 2014 msrb@suse.com
- Update HTML page that serves vnc client applet. (bnc#867273)
- u_tigervnc-dont-send-ascii-control-characters.patch
  * Send CTRL+[A-Z] combinations instead of ascii control characters.
    (bnc#864666)
* Mon Feb 24 2014 msrb@suse.com
- u_arch-Fix-image-and-bitmap-byte-order-for-ppc64le.patch:
  arch: Fix image and bitmap byte order for ppc64le (bnc#865069)
* Thu Feb 13 2014 msrb@suse.com
- Readd vncpasswd.arg for compatibility with installation system
  and potentially another users. (bnc#855246)
* Fri Feb  7 2014 msrb@suse.com
- Drop tigervnc-sf3492503.diff, tigervnc-sf3495623.diff and
  tigervnc-sf3495623.patch.old (not used and not needed).
- Update tigervnc-sf3492352.diff and tigervnc-sf3495623.patch.
* Fri Jan 10 2014 sndirsch@suse.com
- do not include vnc Xserver module and xorg.conf snippet on s390x
* Thu Jan  9 2014 msrb@suse.com
- Remove unnecessary BuildRequires for binutils-gold.
* Mon Dec 16 2013 msrb@suse.com
- Exclude xorg-server-1.13.0/hw/xfree86/modes/xf86gtf.c and
  xorg-server-1.13.0/hw/xfree86/utils/gtf/gtf.c from xserver
  sources. (bnc#855566)
- n_tigervnc-dont-build-gtf.patch
  * Fix build with gtf files excluded. (bnc#855566)
* Tue Dec  3 2013 msrb@suse.com
- tigervnc-clean-pressed-key-on-exit.patch
  * Send release events for pressed keys after X I/O error.
    (bnc#670448)
* Mon Nov 18 2013 msrb@suse.com
- Update to 1.3.0.
- Build xorg-x11-Xvnc package from this sources.
* Wed Sep 19 2012 werner@suse.de
- Make it build with latest TeXLive 2012 and use pdf engine
* Wed Mar 21 2012 jengelh@medozas.de
- Add missing tarball
- Parallel build with %%_smp_mflags
- Remove redundant sections
* Fri Feb 24 2012 giecrilj@stegny.2a.pl
- bump to 1.1 (current stable)
- add documentation (bnc#748504)
- build dynamic server
- eliminate gethostbyname, patch submitted upstream
- incidental clean-up
* Wed Feb  9 2011 sndirsch@novell.com
- added jpeg-devel to BuildRequires
* Wed Feb  9 2011 sndirsch@novell.com
- use system jpeg for building
- fixed xkb path
- added more reasonable options for Xvfb building
* Wed Feb  9 2011 sndirsch@novell.com
- added Reinhard's xdmcp fix (bnc #625593)
* Wed Feb  9 2011 sndirsch@novell.com
- TigerVNC build
  * fix fontpatch
  * cleanup
* Wed Feb  9 2011 sndirsch@novell.com
- build Xvnc of TigerVNC project when %%tigervnc is set; make this
  the default for now
* Tue Feb  8 2011 sndirsch@novell.com
- latest version of Perl script
* Thu Feb  3 2011 sndirsch@novell.com
- renamed package from xorg-x11-Xvnc-ng to xorg-x11-Xvnc
* Thu Feb  3 2011 sndirsch@novell.com
- rewritten wrapper script in Perl
* Wed Jan 26 2011 sndirsch@novell.com
- added services file for SuSEfirewall2
* Wed Jan 26 2011 sndirsch@novell.com
- created package
